/*
 *
 *			      xTHOT
 *		    TCP/IP Hacking 0minous Tool
 *			    Version 1.0
 *		    1999 TCP/IP Tools Unlimited 
 *			  (C)1999 FuSyS
 *
 *			   fusys@usa.net
 *
 *
 *
 * mem.c - uso di IPC, memoria condivisa, threads e mutex per gestire il db
 *
 */
 
#include "xTHOT.h"

#define MAXNODES 500
#define PERMS 600
#define ADD 1
#define DEL 0

struct tcpconn *netc=0, tmp;
int len, shmid;
char buff[100];
unsigned char *saddr, *daddr;

void ipcup(void)
{
	len=sizeof(struct tcpconn)*MAXNODES;

	pthread_mutex_init(&mutex, NULL);
	if((shmid=shmget(IPC_PRIVATE, len, PERMS|IPC_CREAT))<0)
        g_error("IPCUP() Errata allocazione memoria condivisa\n");
	if((netc=shmat(shmid, NULL, 0))<0) 
        g_error("IPCUP() Errato uso memoria condivisa\n");

}

void ipcdown(void)
{
	pthread_mutex_lock(&mutex);
	if(shmctl(shmid, IPC_RMID, NULL) <0)
	g_message("Memoria Condivisa non rimossa\n");
	pthread_mutex_unlock(&mutex);
    	pthread_mutex_destroy(&mutex);

}	

int addc(struct iphdr *ip_p, struct tcphdr *tcp_p)
{
	int i=0;        

    	pthread_mutex_lock(&mutex);				
    	for(;i<MAXNODES;i++)
		if(ip_p->saddr==netc[i].saddr && ip_p->daddr==netc[i].daddr
		&& tcp_p->source==netc[i].source && tcp_p->dest==netc[i].dest){
        		pthread_mutex_unlock(&mutex);
			return(0);
    		}

    	for(i=0;i<MAXNODES;i++){
		if(netc[i].saddr)continue;
		else{
	    	netc[i].saddr=ip_p->saddr;
	    	netc[i].daddr=ip_p->daddr;
	    	netc[i].source=tcp_p->source;
            	netc[i].dest=tcp_p->dest;
            	pthread_mutex_unlock(&mutex);
		return(ADD);
		}
    	}
	pthread_mutex_unlock(&mutex);
	return(0);
}

int delc(struct iphdr *ip_p, struct tcphdr *tcp_p)
{
	int i=0;

    	pthread_mutex_lock(&mutex);               
    	for(;i<MAXNODES;i++)
		if(ip_p->saddr==netc[i].saddr && ip_p->daddr==netc[i].daddr
		&& tcp_p->source==netc[i].source && tcp_p->dest==netc[i].dest){
			memset(&netc[i], 0, sizeof(netc[i]));
			pthread_mutex_unlock(&mutex);
			return(DEL);
    		}
    	pthread_mutex_unlock(&mutex);
    	return(0);		
}

void dumptcp(GtkWidget *widg, gpointer *data)
{
	GtkWidget *text, *button, *dialog;
	int i=0, j=0;

	dialog = gtk_dialog_new();
	gtk_signal_connect(GTK_OBJECT(dialog), "destroy",
		GTK_SIGNAL_FUNC(close_dialog), &dialog);
	gtk_window_set_title(GTK_WINDOW(dialog), "Connessioni TCP Attive");
	gtk_widget_set_usize(dialog, 350, 400);
	gtk_container_border_width(GTK_CONTAINER(dialog), 5);

	text = gtk_text_new(NULL, NULL);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), text, 
				TRUE, TRUE, 0);
	gtk_text_set_editable(GTK_TEXT(text), FALSE);
	gtk_widget_show(text);

	button = gtk_button_new_with_label("OK");
	gtk_signal_connect(GTK_OBJECT(button), "clicked", 
		GTK_SIGNAL_FUNC(click_dialog), dialog);
	GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area), button,
			TRUE, TRUE, 0);
	gtk_widget_grab_default(button);
	gtk_widget_show(button);

	pthread_mutex_lock(&mutex);
	for(; i<MAXNODES; i++)
	if(netc[i].saddr) {
		saddr=(unsigned char *)&(netc[i].saddr);
		daddr=(unsigned char *)&(netc[i].daddr);
		sprintf(buff,"\t(%d)\t%u.%u.%u.%u:%d  <-->  %u.%u.%u.%u:%d\n",
		i+1, saddr[0], saddr[1], saddr[2], saddr[3],
		ntohs(netc[i].source), daddr[0], daddr[1], daddr[2],
		daddr[3], ntohs(netc[i].dest));	
		j++;
		gtk_text_insert(GTK_TEXT(text), NULL, NULL, NULL, buff,
				strlen(buff));
    	}
	if(!j) {
		sprintf(buff, "\t Nessuna connessione TCP nel DataBase ...\n");
		gtk_text_insert(GTK_TEXT(text), NULL, NULL, NULL, buff,
				strlen(buff));
	}
	pthread_mutex_unlock(&mutex);
	gtk_widget_show(dialog);
	gtk_grab_add(dialog);
    	return;
}

void clearbase(GtkWidget *widg, gpointer *data)	
{	
	int i;
	
	pthread_mutex_lock(&mutex);
	for(i=0;i<MAXNODES;i++)
		memset(&netc[i], 0, sizeof(netc[i]));
	pthread_mutex_unlock(&mutex);
}

void list_init(void)
{
	int i=0, j=0;
	char buffers[MAXNODES][50];
	pthread_mutex_lock(&mutex);
	netlist=NULL;
	for(; i<MAXNODES; i++)
	if(netc[i].saddr) {
		saddr=(unsigned char *)&(netc[i].saddr);
		daddr=(unsigned char *)&(netc[i].daddr);
		sprintf(buffers[i],
		"(%d) %u.%u.%u.%u:%d  <-->  %u.%u.%u.%u:%d",
		i+1, saddr[0], saddr[1], saddr[2], saddr[3],
		ntohs(netc[i].source), daddr[0], daddr[1], daddr[2],
		daddr[3], ntohs(netc[i].dest));	
		j++;
		netlist=g_list_append(netlist, buffers[i]);
    	}
	if(!j) {
		sprintf(buffers[0], 
		"\t Nessuna connessione TCP nel DataBase ...");
		netlist=g_list_append(netlist, buffers[0]);
	}
	pthread_mutex_unlock(&mutex);
	gtk_combo_set_popdown_strings(GTK_COMBO(combo), netlist);	
}

struct tcpconn *isconn(int target)
{       
    pthread_mutex_lock(&mutex);                              
    if(netc[--target].saddr){                   
        memcpy(&tmp,&netc[target],sizeof(tmp));
        pthread_mutex_unlock(&mutex);
        return(&tmp);                   
    }
    pthread_mutex_unlock(&mutex);        
    return((int)(struct tcpconn *)0);
}

