/*
 *
 *                            xTHOT
 *                  TCP/IP Hacking 0minous Tool
 *                          Version 1.0
 *                  1999 TCP/IP Tools Unlimited
 *                       (C)1999 FuSyS
 *
 *                        fusys@usa.net
 *
 *
 *
 * utils.c - varie ed eventuali per giocare con il NBO, i checksum ed i socket
 *	     di basso livello
 *	
 */

#include "xTHOT.h"

char *ntoa(unsigned long ip) {
        static char buff[18];
        char *p;
        p = (char *) &ip;
        sprintf(buff, "%d.%d.%d.%d",
                (p[0] & 255), (p[1] & 255), (p[2] & 255), (p[3] & 255));
        return(buff);
}

char *dumpHW (unsigned char *hw_s) {
        static char buffer[ETH_ALEN];
        sprintf(buffer, "%02x:%02x:%02x:%02x:%02x:%02x",
           hw_s[0], hw_s[1], hw_s[2], hw_s[3], hw_s[4], hw_s[5]);
        return buffer;
}

/*
 * Linux Kernel Fast IP Checksum
 */

unsigned short ip_fast_csum(unsigned char * iph, unsigned int ihl) {
        unsigned int sum;

        __asm__ __volatile__("
            movl (%1), %0
            subl $4, %2
            jbe 2f
            addl 4(%1), %0
            adcl 8(%1), %0
            adcl 12(%1), %0
1:          adcl 16(%1), %0
            lea 4(%1), %1
            decl %2
            jne 1b
            adcl $0, %0
            movl %0, %2
            shrl $16, %0
            addw %w2, %w0
            adcl $0, %0
            notl %0
2:
            "
        : "=r" (sum), "=r" (iph), "=r" (ihl)
        : "1" (iph), "2" (ihl));
        return(sum);
}

u_long nameResolve(char *hostname)
{
  struct in_addr addr;
  struct hostent *hostEnt;

  if((addr.s_addr=inet_addr(hostname)) == -1) {
    if(!(hostEnt=gethostbyname(hostname))) {
        printf("Name Resolution Error:`%s`\n",hostname);
        clean_exit();
    }
    bcopy(hostEnt->h_addr,(char *)&addr.s_addr,hostEnt->h_length);
  }
  return addr.s_addr;
}

char *hostLookup(u_long in)
{
  char hostname[1024];
  struct in_addr addr;
  struct hostent *hostEnt;

  bzero(&hostname,sizeof(hostname));
  addr.s_addr = in;
  hostEnt = gethostbyaddr((char *)&addr, sizeof(struct in_addr),AF_INET);

  if(!hostEnt)
    strcpy(hostname,(char *)inet_ntoa(addr));
  else
    strcpy(hostname,hostEnt->h_name);

  return(strdup(hostname));
}

/*
 *  Ripped From route|daemon9 [Juggernaut v1]
 */

unsigned short in_cksum(unsigned char *buff, int len)
{
    unsigned long sum = 0;
    if (len>3){
        __asm__("clc\n"
        "1:\t"
        "lodsl\n\t"
        "adcl %%eax, %%ebx\n\t"
        "loop 1b\n\t"
        "adcl $0, %%ebx\n\t"
        "movl %%ebx, %%eax\n\t"
        "shrl $16, %%eax\n\t"
        "addw %%ax, %%bx\n\t"
        "adcw $0, %%bx"
        : "=b" (sum) , "=S" (buff)
        : "0" (sum), "c" (len >> 2) ,"1" (buff)
        : "ax", "cx", "si", "bx" );
    }
    if(len&2){
        __asm__("lodsw\n\t"
        "addw %%ax, %%bx\n\t"
        "adcw $0, %%bx"
        : "=b" (sum), "=S" (buff)
        : "0" (sum), "1" (buff)
        : "bx", "ax", "si");
    }
    if(len&1){
        __asm__("lodsb\n\t"
        "movb $0, %%ah\n\t"
        "addw %%ax, %%bx\n\t"
        "adcw $0, %%bx"
        : "=b" (sum), "=S" (buff)
        : "0" (sum), "1" (buff)
        : "bx", "ax", "si");
    }
    sum =~sum;
    return(sum&0xffff);
}

int sniff_pk
(int sniff_fd, char *buffer, int *proto, int *tcpstart)
{
        struct iphdr    *IP;
        char    sniff_buffer[MTU];
        int pack_len;

        pack_len = read(sniff_fd, sniff_buffer, MTU);
        if (read > 0) {
                pack_len -=IF_LEN;
                memcpy(buffer, sniff_buffer+IF_LEN, pack_len);
		IP = (struct iphdr *)buffer;
		if(IP->protocol==IPPROTO_TCP)*proto=IP->protocol;
		if(tcpstart != NULL)
                *tcpstart =(IP->ihl << 2);
        }
        return pack_len;
}

int wait_pk(int fd,struct pk_numba *infoz, unsigned long saddr,
                unsigned short source, unsigned long daddr,
                unsigned short dest, int wp_flags)
{
	char wp_buffer[1500];
	struct iphdr *ip;
	struct tcphdr *tcp;
	int proto;
	int tcpstart;
	unsigned short flags;

	while(1) {
	 while(sniff_pk(fd, wp_buffer, &proto, &tcpstart)>0) {
	    if(proto==IPPROTO_TCP) {
    	 	ip = (struct iphdr *) wp_buffer;
    		tcp = (struct tcphdr *) (wp_buffer+tcpstart);
    		if(saddr==ip->saddr && daddr==ip->daddr) {
      		    if(tcp->source==htons(ntohs(source)) &&
			tcp->dest==htons(ntohs(dest))) {
			flags=(int)(tcp+13);
        		if( (wp_flags==0) || ((flags)&wp_flags))
          		{
       				infoz->source=ntohs(tcp->source);
       				infoz->dest=ntohs(tcp->dest);
       				infoz->seq=ntohl(tcp->seq);
       				infoz->ack_seq=ntohl(tcp->ack_seq);
       				infoz->datalen = ntohs(ip->tot_len) -
                       		(ip->ihl << 2) - (tcp->doff << 2);
                                infoz->data = (char *)(wp_buffer+
                                (sizeof(struct iphdr)+sizeof(struct tcphdr)));
       				alarm(0);
       				return 0;
		        }
        	    }
      	       	}
            }
        }
    }
}
